﻿using System;
using System.Drawing;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace CSharpExample.Common
{
    public partial class LongOperationControl : UserControl
    {
        private readonly GraphicsPath roundedRectanglePath;
        private readonly Timer operationProgressTimer;
        private TimeSpan elapsedTime = TimeSpan.Zero;

        public string ProgressMessage
        {
            get { return lblProgressMessage.Text; }
            set { lblProgressMessage.Text = value; }
        }
        public LongOperationControl()
        {
            InitializeComponent();
            Localize();
            //*
            int radius = 10;
            int width = this.Width - radius * 4;
            int height = this.Height - radius * 4;

            lblProgressMessage.Text = "";

            roundedRectanglePath = new GraphicsPath();

          
            roundedRectanglePath.AddLine(radius, 0, width, 0);
            roundedRectanglePath.AddArc(width, 0, 2 * radius, 2 * radius, 270, 90);
            roundedRectanglePath.AddLine(width + 2 * radius, radius, width + 2 * radius, radius + height);
            roundedRectanglePath.AddArc(width, height, 2 * radius, 2 * radius, 0, 90);
            roundedRectanglePath.AddLine(radius, height + 2 * radius, width, height + 2 * radius);
            roundedRectanglePath.AddArc(0, height, 2 * radius, 2 * radius, 90, 90);
            roundedRectanglePath.AddLine(0, radius, 0, radius + height);
            roundedRectanglePath.AddArc(0, 0, 2 * radius, 2 * radius, 180, 90);
           
            this.Region = new Region(roundedRectanglePath);
            //*/
            label1.Text = "Пожалуйста  подождите" + Environment.NewLine + elapsedTime;

            operationProgressTimer = new Timer();
            operationProgressTimer.Interval = 1000;
            operationProgressTimer.Tick += (sender, e) =>
            {
                elapsedTime = elapsedTime.Add(TimeSpan.FromSeconds(1));
                label1.Text = "Пожалуйста  подождите" + Environment.NewLine + elapsedTime;
            };
            operationProgressTimer.Start();

        }

        void Localize()
        {
            this.label1.Text = "Пожалуйста  подождите";
        }

    }
}
