﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading;
using System.Web.Script.Serialization;
using System.Windows.Forms;

namespace CSharpExample
{
    public partial class DealProcessingForm : Form
    {
        private readonly Deal _deal;
        private readonly string _url;
        private readonly CookieContainer _cookieContainer;

        public DealProcessingForm(Deal deal, string url, CookieContainer cookieContainer)
        {
            _deal = deal;
            _url = url;
            _cookieContainer = cookieContainer;
            InitializeComponent();
            
        }

        private void btnPostJson_Click(object sender, EventArgs e)
        {
            textBox2.Text = Post(textBox1.Text);
        }

        private void btnDeleteJson_Click(object sender, EventArgs e)
        {
            textBox2.Text = Delete(textBox1.Text);
        }

        string Delete(string data)
        {
            
            byte[] dataByte = Encoding.UTF8.GetBytes(data);

            var postRequest = (HttpWebRequest)WebRequest.Create(_url);
            //Method type
            postRequest.Method = "DELETE";
            //var container = new CookieContainer();
            //container.Add(SessionManager.PassportCookie);
            //postRequest.CookieContainer = container;


            postRequest.CookieContainer = _cookieContainer;

            // Data type - message body coming in xml
            postRequest.ContentType = "text/plain";
            postRequest.KeepAlive = false;
            postRequest.Timeout = Timeout.Infinite;
            //Content length of message body
            postRequest.ContentLength = dataByte.LongLength;


            // Get the request stream
            Stream postStream = postRequest.GetRequestStream();
            // Write the data bytes in the request stream
            postStream.Write(dataByte, 0, dataByte.Length);

            //Get response from server
            var postResponse = (HttpWebResponse)postRequest.GetResponse();
            var reader = new StreamReader(postResponse.GetResponseStream(), Encoding.UTF8);

            //Log(reader.ReadToEnd().ToString());
            return reader.ReadToEnd().ToString();
        }

        string Post(string data)
        {
            
            byte[] dataByte = Encoding.UTF8.GetBytes(data);

            var postRequest = (HttpWebRequest)WebRequest.Create(_url);
            //Method type
            postRequest.Method = "POST";
            postRequest.CookieContainer = _cookieContainer;
            // Data type - message body coming in xml
            postRequest.ContentType = "text/plain";
            postRequest.KeepAlive = false;
            postRequest.Timeout = Timeout.Infinite;
            //Content length of message body
            postRequest.ContentLength = dataByte.Length;

            // Get the request stream
            Stream postStream = postRequest.GetRequestStream();
            // Write the data bytes in the request stream
            postStream.Write(dataByte, 0, dataByte.Length);

            //Get response from server
            var postResponse = (HttpWebResponse)postRequest.GetResponse();
            var reader = new StreamReader(postResponse.GetResponseStream(), Encoding.UTF8);


            return reader.ReadToEnd();
        }

        private void rbPost_CheckedChanged(object sender, EventArgs e)
        {
            var env = Deal.GetPostRequest(new Deal[] { _deal }, true);
            var js = new JavaScriptSerializer();
            textBox1.Text = js.Serialize(env);
        }

        private void rbDelete_CheckedChanged(object sender, EventArgs e)
        {
            var env = Deal.GetDeleteRequest(new Deal[] { _deal }, "Тестовая причина удаления");
            var js = new JavaScriptSerializer();
            textBox1.Text = js.Serialize(env);
        }
    }
}
